// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/18AO8/18AO8_Linux_1.x_and_2.x_DN/driver/18ao8.h $
// $Rev: 52875 $
// $Date: 2023-04-18 08:57:44 -0500 (Tue, 18 Apr 2023) $

// 18AO8: Device Driver: header file

#ifndef	__18AO8_H__
#define	__18AO8_H__

#include "gsc_common.h"
#include "gsc_pci9656.h"



// macros *********************************************************************

#define	AO8_BASE_NAME						"18ao8"

// IOCTL command codes
#define	AO8_IOCTL_REG_READ					OS_IOCTL_RW( 0,  12, gsc_reg_t)
#define	AO8_IOCTL_REG_WRITE					OS_IOCTL_W ( 1,  12, gsc_reg_t)
#define	AO8_IOCTL_REG_MOD					OS_IOCTL_W ( 2,  12, gsc_reg_t)
#define	AO8_IOCTL_QUERY						OS_IOCTL_RW( 3,	  4, s32)
#define	AO8_IOCTL_INITIALIZE				OS_IOCTL   ( 4)
#define	AO8_IOCTL_AUTO_CALIBRATE			OS_IOCTL   ( 5)
#define	AO8_IOCTL_AUTO_CAL_STS				OS_IOCTL_R ( 6,	  4, s32)
#define	AO8_IOCTL_AO_CONFIG					OS_IOCTL_RW( 7,	  4, s32)
#define	AO8_IOCTL_AUX_CLOCK_MODE			OS_IOCTL_RW( 8,	  4, s32)
#define	AO8_IOCTL_AUX_IN_POL				OS_IOCTL_RW( 9,	  4, s32)
#define	AO8_IOCTL_AUX_OUT_POL				OS_IOCTL_RW(10,	  4, s32)
#define	AO8_IOCTL_AUX_NOISE					OS_IOCTL_RW(11,	  4, s32)
#define	AO8_IOCTL_AUX_SYNC_MODE				OS_IOCTL_RW(12,	  4, s32)
#define	AO8_IOCTL_BUF_CLEAR					OS_IOCTL   (13)
#define	AO8_IOCTL_BUF_MODE					OS_IOCTL_RW(14,	  4, s32)
#define	AO8_IOCTL_BUF_OVER_DATA				OS_IOCTL_RW(15,	  4, s32)
#define	AO8_IOCTL_BUF_OVER_FRAME			OS_IOCTL_RW(16,	  4, s32)
#define	AO8_IOCTL_BUF_STATUS				OS_IOCTL_R (17,	  4, s32)
#define	AO8_IOCTL_BUF_FILL_LEVEL			OS_IOCTL_R (18,	  4, s32)
#define	AO8_IOCTL_BUF_THRESH_LEVEL			OS_IOCTL_RW(19,	  4, s32)
#define	AO8_IOCTL_BUF_THRESH_STATUS			OS_IOCTL_R (20,	  4, s32)
#define	AO8_IOCTL_BURST_ENABLE				OS_IOCTL_RW(21,	  4, s32)
#define	AO8_IOCTL_BURST_READY				OS_IOCTL_R (22,	  4, s32)
#define	AO8_IOCTL_BURST_TRIG_SRC			OS_IOCTL_RW(23,	  4, s32)
#define	AO8_IOCTL_CHANNEL_SEL				OS_IOCTL_RW(24,	  4, s32)
#define	AO8_IOCTL_CLOCK_ENABLE				OS_IOCTL_RW(25,	  4, s32)
#define	AO8_IOCTL_CLOCK_READY				OS_IOCTL_R (26,	  4, s32)
#define	AO8_IOCTL_CLOCK_SRC					OS_IOCTL_RW(27,	  4, s32)
#define	AO8_IOCTL_CLOCK_SW					OS_IOCTL   (28)
#define	AO8_IOCTL_DATA_FORMAT				OS_IOCTL_RW(29,	  4, s32)
#define	AO8_IOCTL_DIO_DIR_OUT				OS_IOCTL_RW(30,	  4, s32)
#define	AO8_IOCTL_DIO_READ					OS_IOCTL_R (31,	  4, s32)
#define	AO8_IOCTL_DIO_WRITE					OS_IOCTL_RW(32,	  4, s32)
#define	AO8_IOCTL_GEN_C_ENABLE				OS_IOCTL_RW(33,	  4, s32)
#define	AO8_IOCTL_GEN_C_NDIV				OS_IOCTL_RW(34,	  4, s32)
#define	AO8_IOCTL_GEN_D_ENABLE				OS_IOCTL_RW(35,	  4, s32)
#define	AO8_IOCTL_GEN_D_NDIV				OS_IOCTL_RW(36,	  4, s32)
#define	AO8_IOCTL_IRQ_ENABLE				OS_IOCTL_RW(37,	  4, s32)
#define	AO8_IOCTL_LOAD_READY				OS_IOCTL_R (38,	  4, s32)
#define	AO8_IOCTL_LOAD_REQUEST				OS_IOCTL   (39)
#define	AO8_IOCTL_OUTPUT_MODE				OS_IOCTL_RW(40,	  4, s32)
#define	AO8_IOCTL_RANGE						OS_IOCTL_RW(41,	  4, s32)
#define	AO8_IOCTL_SELFTEST_BUF_CLEAR		OS_IOCTL   (42)
#define	AO8_IOCTL_SELFTEST_DATA_READY		OS_IOCTL_R (43,	  4, s32)
#define	AO8_IOCTL_SELFTEST_MODE				OS_IOCTL_RW(44,	  4, s32)
#define	AO8_IOCTL_SELFTEST_PERFORM			OS_IOCTL   (45)
#define	AO8_IOCTL_SELFTEST_READ				OS_IOCTL_RW(46, 512, ao8_selftest_data_t)
#define	AO8_IOCTL_TRIGGER_SW				OS_IOCTL   (47)
#define	AO8_IOCTL_TX_IO_ABORT				OS_IOCTL_R (48,	  4, s32)
#define	AO8_IOCTL_TX_IO_MODE				OS_IOCTL_RW(49,	  4, s32)
#define	AO8_IOCTL_TX_IO_OVERFLOW_DATA		OS_IOCTL_RW(50,	  4, s32)
#define	AO8_IOCTL_TX_IO_OVERFLOW_FRAME		OS_IOCTL_RW(51,	  4, s32)
#define	AO8_IOCTL_TX_IO_TIMEOUT				OS_IOCTL_RW(52,	  4, s32)
#define	AO8_IOCTL_WAIT_CANCEL				OS_IOCTL_RW(53,  28, gsc_wait_t)
#define	AO8_IOCTL_WAIT_EVENT				OS_IOCTL_RW(54,  28, gsc_wait_t)
#define	AO8_IOCTL_WAIT_STATUS				OS_IOCTL_RW(55,  28, gsc_wait_t)
#define	AO8_IOCTL_XCVR_OUTPUT				OS_IOCTL_RW(56,	  4, s32)
#define	AO8_IOCTL_XCVR_POL					OS_IOCTL_RW(57,	  4, s32)
#define	AO8_IOCTL_XCVR_TYPE					OS_IOCTL_RW(58,	  4, s32)



//*****************************************************************************
// AO8_IOCTL_REG_READ
// AO8_IOCTL_REG_WRITE
// AO8_IOCTL_REG_MOD
//
#define	AO8_REG_ENCODE(s,o)					GSC_REG_ENCODE(GSC_REG_TYPE_BAR2,(s),(o))
// Parameter:	gsc_reg_t*
#define	AO8_GSC_BCR							AO8_REG_ENCODE(4,0x00)// Board Control Register
#define	AO8_GSC_DIOPR						AO8_REG_ENCODE(4,0x04)// Digital I/O Port Register
#define	AO8_GSC_SCR							AO8_REG_ENCODE(4,0x14)// Selftest Cofiguration Register
#define	AO8_GSC_SDBR						AO8_REG_ENCODE(4,0x18)// Selftest Data Buffer Register
#define	AO8_GSC_ASIOCR						AO8_REG_ENCODE(4,0x1C)// Auxiliary Sync I/O Register
#define	AO8_GSC_PSR							AO8_REG_ENCODE(4,0x30)// Primary Status Register
#define	AO8_GSC_ACR							AO8_REG_ENCODE(4,0x34)// Assembly Configuration Register
#define	AO8_GSC_AVR							AO8_REG_ENCODE(4,0x38)// Auto Cal Values Register
#define	AO8_GSC_BOOR						AO8_REG_ENCODE(4,0x3C)// Buffered Output Operations Register
#define	AO8_GSC_OBTR						AO8_REG_ENCODE(4,0x40)// Output Buffer Threshold Register
#define	AO8_GSC_OBSR						AO8_REG_ENCODE(4,0x44)// Output Buffer Size Register
#define	AO8_GSC_AOBR						AO8_REG_ENCODE(4,0x48)// Analog Output Buffer Register
#define	AO8_GSC_RCGR						AO8_REG_ENCODE(4,0x4C)// Rate-C Generator Register
#define	AO8_GSC_RDGR						AO8_REG_ENCODE(4,0x50)// Rate-D Generator Register
#define	AO8_GSC_OCR							AO8_REG_ENCODE(4,0x54)// Output Configuration Register

//*****************************************************************************
// AO8_IOCTL_QUERY
//
//	Parameter:	s32
//		Pass in a value from the list below.
//		The value returned is the answer to the query.

typedef enum
{
	AO8_QUERY_AUTO_CAL_MS,	// Max auto-cal period in ms.
	AO8_QUERY_CHANNEL_MASK,	// Mask of valid channel enable bits.
	AO8_QUERY_CHANNEL_MAX,	// Maximum number of channels supported.
	AO8_QUERY_CHANNEL_QTY,	// The number of A/D channels. ACR D16
	AO8_QUERY_COUNT,		// Number of query options.
	AO8_QUERY_CUSTOM_FEAT,	// Custom Features. ACR D19-D20
	AO8_QUERY_DEVICE_TYPE,	// Value from gsc_dev_type_t
	AO8_QUERY_FGEN_MAX,		// Rate Generator maximum output rate.
	AO8_QUERY_FGEN_MIN,		// Rate Generator minimum output rate.
	AO8_QUERY_FIFO_SIZE,	// FIFO depth in 32-bit samples
	AO8_QUERY_FREF_DEFAULT,	// The default Fref. ACR D17-D18
	AO8_QUERY_FSAMP_MAX,	// Maximum sample rate.
	AO8_QUERY_FSAMP_MIN,	// Minimum sample rate.
	AO8_QUERY_INIT_MS,		// Max initialize period in ms.
	AO8_QUERY_NDIV_MAX,		// Maximum rate generator Ndiv value.
	AO8_QUERY_NDIV_MIN,		// Maximum rate generator Ndiv value.
	AO8_QUERY_SELFTEST_MS,	// Selftest period in ms.
	AO8_QUERY_LAST			// Must be very last entry.

} ao8_query_t;

#define	AO8_IOCTL_QUERY_ERROR				(-1)	// A query request is unknown of invalid.

// AO8_QUERY_CUSTOM_FEAT options: ACR D19-D20
// None defined at present.

//*****************************************************************************
// AO8_IOCTL_INITIALIZE						BCR D31
//
//	Parameter:	None

//*****************************************************************************
// AO8_IOCTL_AUTO_CALIBRATE					BCR D28, D29
//
//	Parameter:	None

//*****************************************************************************
// AO8_IOCTL_AUTO_CAL_STS					BCR D28, D29
//
//	Parameter:	s32*
//		One of the below values is returned.
#define	AO8_AUTO_CAL_STS_ACTIVE				0
#define	AO8_AUTO_CAL_STS_FAIL				1
#define	AO8_AUTO_CAL_STS_PASS				2

//*****************************************************************************
// AO8_IOCTL_AO_CONFIG						OCR D16
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8_AO_CONFIG_SE					0
#define	AO8_AO_CONFIG_DIFF					1

//*****************************************************************************
// AO8_IOCTL_AUX_CLOCK_MODE					ASIOCR D0-D1
// AO8_IOCTL_AUX_SYNC_MODE					ASIOCR D2-D3
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8_AUX_MODE_DISABLE				0
#define	AO8_AUX_MODE_INPUT					1
#define	AO8_AUX_MODE_OUTPUT					2

//*****************************************************************************
// AO8_IOCTL_AUX_IN_POL						ASIOCR D8
// AO8_IOCTL_AUX_OUT_POL					ASIOCR D9
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8_AUX_POL_HI						0
#define	AO8_AUX_POL_LOW						1

//*****************************************************************************
// AO8_IOCTL_AUX_NOISE						ASIOCR D10
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8_AUX_NOISE_LOW					0	// output 90-120ns, input 135ns
#define	AO8_AUX_NOISE_HI					1	// output 1.3us, inout 1.8us

//*****************************************************************************
// AO8_IOCTL_BUF_CLEAR						BOOR D11, D16, D17
//
//	Parameter:	None.

//*****************************************************************************
// AO8_IOCTL_BUF_MODE						BOOR D8
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8_BUF_MODE_OPEN					0
#define	AO8_BUF_MODE_CIRC					1

//*****************************************************************************
// AO8_IOCTL_BUF_OVER_DATA					BOOR D16
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8_BUF_OVER_DATA_CLR				0
#define	AO8_BUF_OVER_DATA_CHK				(-1)

//		The service returns one of the below listed values.
#define	AO8_BUF_OVER_DATA_NO				0
#define	AO8_BUF_OVER_DATA_YES				1

//*****************************************************************************
// AO8_IOCTL_BUF_OVER_FRAME					BOOR D17
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8_BUF_OVER_FRAME_CLR				0
#define	AO8_BUF_OVER_FRAME_CHK				(-1)

//		The service returns one of the below listed values.
#define	AO8_BUF_OVER_FRAME_NO				0
#define	AO8_BUF_OVER_FRAME_YES				1

//*****************************************************************************
// AO8_IOCTL_BUF_STATUS						BOOR D12, D13, D15, OBTR D20
//
//	Parameter:	s32
//		The service returns one of the below listed values.
#define	AO8_BUF_STATUS_EMPTY				0
#define	AO8_BUF_STATUS_AE					1
#define	AO8_BUF_STATUS_AF					2
#define	AO8_BUF_STATUS_FULL					3

//*****************************************************************************
// AO8_IOCTL_BUF_FILL_LEVEL					OBSR D0-D18
//
//	Parameter:	s32
//		Values returned are from zero to 256K.

//*****************************************************************************
// AO8_IOCTL_BUF_THRESH_LEVEL				OBTR D0-D18
//
//	Parameter:	s32
//		Pass in any value from zero to 256K, or
//		-1 to read the current setting.

//*****************************************************************************
// AO8_IOCTL_BUF_THRESH_STATUS				BCR D13, OBTR D20
//
//	Parameter:	s32
//		Values returned are as follows.
#define	AO8_BUF_THRESH_STATUS_CLR			0
#define	AO8_BUF_THRESH_STATUS_SET			1

//*****************************************************************************
// AO8_IOCTL_BURST_ENABLE					BOOR D19
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8_BURST_ENABLE_NO					0
#define	AO8_BURST_ENABLE_YES				1

//*****************************************************************************
// AO8_IOCTL_BURST_READY					BOOR D18
//
//	Parameter:	s32
//		The service returns one of the below listed values.
#define	AO8_BURST_READY_NO					0
#define	AO8_BURST_READY_YES					1

//*****************************************************************************
// AO8_IOCTL_BURST_TRIG_SRC					OCR D14-D15
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8_BURST_TRIG_SRC_RDG				0
#define	AO8_BURST_TRIG_SRC_EXT				2

//*****************************************************************************
// AO8_IOCTL_CHANNEL_SEL					OCR D0-D7
//
//	Parameter:	s32
//		Pass in any valid bitwise combination, or
//		-1 to read the current setting.
//		The range for  4 channel devices is 0x00000 to 0x000F.
//		The range for  8 channel devices is 0x00000 to 0x00FF.

//*****************************************************************************
// AO8_IOCTL_CLOCK_ENABLE					BOOR D5
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8_CLOCK_ENABLE_NO					0
#define	AO8_CLOCK_ENABLE_YES				1

//*****************************************************************************
// AO8_IOCTL_CLOCK_READY					BOOR D6
//
//	Parameter:	s32
//		The service returns one of the below listed values.
#define	AO8_CLOCK_READY_NO					0
#define	AO8_CLOCK_READY_YES					1

//*****************************************************************************
// AO8_IOCTL_CLOCK_SRC						OCR D12-D13
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8_CLOCK_SRC_RCG					0
#define	AO8_CLOCK_SRC_EXT					2

//*****************************************************************************
// AO8_IOCTL_CLOCK_SW						BCR D20, BOOR D7
// The driver will wait upto the Tx I/O Timeout period for the bit to clear.
//
//	Parameter:	None.

//*****************************************************************************
// AO8_IOCTL_DATA_FORMAT					BCR D25
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8_DATA_FORMAT_2S_COMP				0	// Twos Compliment
#define	AO8_DATA_FORMAT_OFF_BIN				1	// Offset Binary

//*****************************************************************************
// AO8_IOCTL_DIO_DIR_OUT					DIOPR D7, D15
//
//	Parameter:	s32
//		Values returned are as follows.
#define	AO8_DIO_DIR_OUT_NONE				0x0000
#define	AO8_DIO_DIR_OUT_D3_D0				0x0080
#define	AO8_DIO_DIR_OUT_D7_D4				0x8000
#define	AO8_DIO_DIR_OUT_D7_D0				0x8080

//*****************************************************************************
// AO8_IOCTL_DIO_READ						DIOPR D0-D3, D8-D11
//
//	Parameter:	s32
//		Values returned are from zero to 0xFF.

//*****************************************************************************
// AO8_IOCTL_DIO_WRITE						DIOPR D0-D3, D8-D11
//
//	Parameter:	s32
//		Pass in any value from zero to 0xFF, or
//		-1 to read the current setting.

//*****************************************************************************
// AO8_IOCTL_GEN_C_ENABLE					BCR D21
// AO8_IOCTL_GEN_D_ENABLE					BCR D22
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8_GEN_ENABLE_NO					0
#define	AO8_GEN_ENABLE_YES					1

//*****************************************************************************
// AO8_IOCTL_GEN_C_NDIV						RCGR D0-D23
// AO8_IOCTL_GEN_D_NDIV						RDGR D0-D23
//
//	Parameter:	s32
//		Pass in any value from 90 to 0xFFFFFF, or
//		-1 to read the current setting.

//*****************************************************************************
// AO8_IOCTL_IRQ_ENABLE						PSR D0-D15
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8_IRQ_AUTO_CAL_DONE				0x0001
#define	AO8_IRQ_SELFTEST_DATA_READY			0x0020
#define	AO8_IRQ_DIO0_L2H					0x0100
#define	AO8_IRQ_BUF_THR_H2L					0x0200
#define	AO8_IRQ_BUF_THR_L2H					0x0400
#define	AO8_IRQ_LOAD_READY_H2L				0x0800
#define	AO8_IRQ_LOAD_READY_L2H				0x1000
#define	AO8_IRQ_BURST_READY					0x2000
#define	AO8_IRQ_BUF_ERROR					0x4000
#define	AO8_IRQ_ALL							0x7F21

//*****************************************************************************
// AO8_IOCTL_LOAD_READY						BOOR D10
//
//	Parameter:	s32
//		The service returns one of the below listed values.
#define	AO8_LOAD_READY_NO					0
#define	AO8_LOAD_READY_YES					1

//*****************************************************************************
// AO8_IOCTL_LOAD_REQUEST					BOOR D9, D10
//	The driver will wait the write timeout for completion.
//
//	Parameter:	None

//*****************************************************************************
// AO8_IOCTL_OUTPUT_MODE					BCR D18
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8_OUTPUT_MODE_SEQUENTIAL			0
#define	AO8_OUTPUT_MODE_SIMULTANEOUS		1

//*****************************************************************************
// AO8_IOCTL_RANGE							OCR D8-D10
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8_RANGE_2_5						0
#define	AO8_RANGE_5							1
#define	AO8_RANGE_10						2

//*****************************************************************************
// AO8_IOCTL_SELFTEST_BUF_CLEAR				BCR D2
//
//	Parameter:	none

//*****************************************************************************
// AO8_IOCTL_SELFTEST_DATA_READY			BCR D1
//
//	Parameter:	s32*
//		This service returns one of the below values.
#define	AO8_SELFTEST_DATA_READY_NO			0
#define	AO8_SELFTEST_DATA_READY_YES			1

//*****************************************************************************
// AO8_IOCTL_SELFTEST_MODE					SCR D0-D3
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8_SELFTEST_MODE_ZERO				0
#define	AO8_SELFTEST_MODE_VREF				1
#define	AO8_SELFTEST_MODE_OUT_0				8
#define	AO8_SELFTEST_MODE_OUT_1				9
#define	AO8_SELFTEST_MODE_OUT_2				10
#define	AO8_SELFTEST_MODE_OUT_3				11
#define	AO8_SELFTEST_MODE_OUT_4				12
#define	AO8_SELFTEST_MODE_OUT_5				13
#define	AO8_SELFTEST_MODE_OUT_6				14
#define	AO8_SELFTEST_MODE_OUT_7				15

//*****************************************************************************
// AO8_IOCTL_SELFTEST_PERFORM				BCR D0
// This services includes a 50ms settling delay.
//
//	Parameter:	none

//*****************************************************************************
// AO8_IOCTL_SELFTEST_READ					SDBR D0-D17
//
//	Parameter:	ao8_selftest_data_t*
//		The buffer is filled with the selftest data from the Selftest Data
//		Buffer.

typedef struct
{
	u32	data[128];
} ao8_selftest_data_t;

//*****************************************************************************
// AO8_IOCTL_TRIGGER_SW						BCR D23, BOOR D20
// The driver will wait upto the Tx I/O Timeout period for the bit clear.
//
//	Parameter:	None.

//*****************************************************************************
// AO8_IOCTL_TX_IO_ABORT
//
//	Parameter:	s32*
//		The returned value is one of the below options.
#define	AO8_IO_ABORT_NO						0
#define	AO8_IO_ABORT_YES					1

//*****************************************************************************
// AO8_IOCTL_TX_IO_MODE
//
//	Parameter:	s32
//		Pass in any of the gsc_io_mode_t options, or
//		-1 to read the current setting.
#define	AO8_IO_MODE_DEFAULT					GSC_IO_MODE_PIO
// GSC_IO_MODE_PIO
// GSC_IO_MODE_BMDMA

//*****************************************************************************
// AO8_IOCTL_TX_IO_OVERFLOW_DATA
// AO8_IOCTL_TX_IO_OVERFLOW_FRAME
//
//	Parameter:	s32
//		Pass in any valid value, or
//		-1 to read the current setting.
#define	AO8_TX_IO_OVERFLOW_IGNORE			0
#define	AO8_TX_IO_OVERFLOW_CHECK			1
#define	AO8_TX_IO_OVERFLOW_DEFAULT			AO8_TX_IO_OVERFLOW_CHECK

//*****************************************************************************
// AO8_IOCTL_TX_IO_TIMEOUT (in seconds)
//
//	Parameter:	s32
//		Pass in any value from the minimim to the maximim, the infinite option,
//		or -1 to read the current setting. The value -1 is returned if the
//		feature is not supported, but this should never happen.
#define	AO8_IO_TIMEOUT_DEFAULT				10
#define	AO8_IO_TIMEOUT_NO_SLEEP				0		// Do not sleep to wait for more data.
#define	AO8_IO_TIMEOUT_MIN					0
#define	AO8_IO_TIMEOUT_MAX					GSC_IO_TIMEOUT_MAX
#define	AO8_IO_TIMEOUT_INFINITE				GSC_IO_TIMEOUT_INFINITE

//*****************************************************************************
// AO8_IOCTL_WAIT_EVENT						all fields must be valid
// AO8_IOCTL_WAIT_CANCEL					fields need not be valid
// AO8_IOCTL_WAIT_STATUS					fields need not be valid
//
//	Parameter:	gsc_wait_t*
// gsc_wait_t.flags - see gsc_common.h
// gsc_wait_t.main - see gsc_common.h
// gsc_wait_t.gsc
#define	AO8_WAIT_GSC_AUTO_CAL_DONE			AO8_IRQ_AUTO_CAL_DONE
#define	AO8_WAIT_GSC_SELFTEST_DATA_READY	AO8_IRQ_SELFTEST_DATA_READY
#define	AO8_WAIT_GSC_BUF_ERROR				AO8_IRQ_BUF_ERROR
#define	AO8_WAIT_GSC_BUF_THR_H2L			AO8_IRQ_BUF_THR_H2L
#define	AO8_WAIT_GSC_BUF_THR_L2H			AO8_IRQ_BUF_THR_L2H
#define	AO8_WAIT_GSC_BURST_READY			AO8_IRQ_BURST_READY
#define	AO8_WAIT_GSC_DIO0_L2H				AO8_IRQ_DIO0_L2H
#define	AO8_WAIT_GSC_LD_RDY_H2L				AO8_IRQ_LOAD_READY_H2L
#define	AO8_WAIT_GSC_LD_RDY_L2H				AO8_IRQ_LOAD_READY_L2H
#define	AO8_WAIT_GSC_ALL					AO8_IRQ_ALL
// gsc_wait_t.alt flags
#define	AO8_WAIT_ALT_ALL					0x0000
// gsc_wait_t.io
#define	AO8_WAIT_IO_TX_ABORT				0x0001
#define	AO8_WAIT_IO_TX_DONE					0x0002
#define	AO8_WAIT_IO_TX_ERROR				0x0004
#define	AO8_WAIT_IO_TX_TIMEOUT				0x0008
#define	AO8_WAIT_IO_ALL						0x000F

//*****************************************************************************
// AO8_IOCTL_XCVR_OUTPUT					OCR D11
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8_XCVR_OUTPUT_DISABLE				0
#define	AO8_XCVR_OUTPUT_ENABLE				1

//*****************************************************************************
// AO8_IOCTL_XCVR_POL						OCR D17
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8_XCVR_POL_DEFAULT				0
#define	AO8_XCVR_POL_INVERT					1

//*****************************************************************************
// AO8_IOCTL_XCVR_TYPE						BCR D5
//
//	Parameter:	s32
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	AO8_XCVR_TYPE_TTL					0
#define	AO8_XCVR_TYPE_LVDS					1



#endif
