// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/18AO8/18AO8_Linux_1.x_and_2.x_DN/samples/irq/perform.c $
// $Rev: 52868 $
// $Date: 2023-04-17 14:42:16 -0500 (Mon, 17 Apr 2023) $

// 18AO8: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _selftest(int fd)
{
	int	errs	= 0;

	errs	+= ao8_irq_enable		(fd, -1, 0, AO8_IRQ_SELFTEST_DATA_READY, NULL);
	errs	+= ao8_selftest_perform	(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _irq_selftest_data_ready_test(int fd)
{
	int	errs	= 0;

	gsc_label("Selftest Data Ready");
	errs	+= ao8_initialize(fd, -1, 0);
	errs	+= irq_wait_test(fd, AO8_WAIT_GSC_SELFTEST_DATA_READY, _selftest);
	errs	+= ao8_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _dio0_l2h(int fd)
{
	int	errs	= 0;

	errs	+= ao8_dio_dir_out	(fd, -1, 0, AO8_DIO_DIR_OUT_D7_D0,	NULL);
	errs	+= ao8_dio_write	(fd, -1, 0, 0x00,					NULL);
	errs	+= ao8_irq_enable	(fd, -1, 0, AO8_IRQ_DIO0_L2H,		NULL);
	errs	+= ao8_dio_write	(fd, -1, 0, 0x01,					NULL);
	return(errs);
}



//*****************************************************************************
static int _irq_dio0_l2h_test(int fd)
{
	int	errs	= 0;

	gsc_label("DIO 0 Low->High");
	errs	+= ao8_initialize(fd, -1, 0);
	errs	+= irq_wait_test(fd, AO8_WAIT_GSC_DIO0_L2H, _dio0_l2h);
	errs	+= ao8_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _buf_thr_h2l(int fd)
{
	int	errs	= 0;
	int	i;

	for (i = 0; i < 100; i++)
		errs	+= ao8_reg_write(fd, -1, 0, AO8_GSC_AOBR, 0);

	errs	+= ao8_buf_thresh_level	(fd, -1, 0, 10,						NULL);
	errs	+= ao8_irq_enable		(fd, -1, 0, AO8_IRQ_BUF_THR_H2L,	NULL);
	errs	+= ao8_buf_thresh_level	(fd, -1, 0, 10000,					NULL);
	return(errs);
}



//*****************************************************************************
static int _irq_buf_thr_h2l_test(int fd)
{
	int	errs	= 0;

	gsc_label("Buffer Threshold Hi->Low");
	errs	+= ao8_initialize(fd, -1, 0);
	errs	+= irq_wait_test(fd, AO8_WAIT_GSC_BUF_THR_H2L, _buf_thr_h2l);
	errs	+= ao8_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _buf_thr_l2h(int fd)
{
	int	errs	= 0;
	int	i;

	for (i = 0; i < 100; i++)
		errs	+= ao8_reg_write(fd, -1, 0, AO8_GSC_AOBR, 0);

	errs	+= ao8_buf_thresh_level	(fd, -1, 0, 10000,					NULL);
	errs	+= ao8_irq_enable		(fd, -1, 0, AO8_IRQ_BUF_THR_L2H,	NULL);
	errs	+= ao8_buf_thresh_level	(fd, -1, 0, 10,						NULL);
	return(errs);
}



//*****************************************************************************
static int _irq_buf_thr_l2h_test(int fd)
{
	int	errs	= 0;

	gsc_label("Buffer Threshold Low->Hi");
	errs	+= ao8_initialize(fd, -1, 0);
	errs	+= irq_wait_test(fd, AO8_WAIT_GSC_BUF_THR_L2H, _buf_thr_l2h);
	errs	+= ao8_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _load_ready_h2l(int fd)
{
	int	errs	= 0;

	errs	+= ao8_buf_mode		(fd, -1, 0, AO8_BUF_MODE_OPEN,		NULL);
	errs	+= ao8_irq_enable	(fd, -1, 0, AO8_IRQ_LOAD_READY_H2L,	NULL);
	errs	+= ao8_buf_mode		(fd, -1, 0, AO8_BUF_MODE_CIRC,		NULL);
	return(errs);
}



//*****************************************************************************
static int _irq_load_ready_h2l_test(int fd)
{
	int	errs	= 0;

	gsc_label("Load Ready Hi->Low");
	errs	+= ao8_initialize(fd, -1, 0);
	errs	+= irq_wait_test(fd, AO8_WAIT_GSC_LD_RDY_H2L, _load_ready_h2l);
	errs	+= ao8_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _load_ready_l2h(int fd)
{
	int	errs	= 0;

	errs	+= ao8_buf_mode		(fd, -1, 0, AO8_BUF_MODE_CIRC,		NULL);
	errs	+= ao8_irq_enable	(fd, -1, 0, AO8_IRQ_LOAD_READY_L2H,	NULL);
	errs	+= ao8_buf_mode		(fd, -1, 0, AO8_BUF_MODE_OPEN,		NULL);
	return(errs);
}



//*****************************************************************************
static int _irq_load_ready_l2h_test(int fd)
{
	int	errs	= 0;

	gsc_label("Load Ready Low->Hi");
	errs	+= ao8_initialize(fd, -1, 0);
	errs	+= irq_wait_test(fd, AO8_WAIT_GSC_LD_RDY_L2H, _load_ready_l2h);
	errs	+= ao8_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _burst_ready(int fd)
{
	int	errs	= 0;
	int	i;

	errs	+= ao8_burst_enable	(fd, -1, 0, AO8_BURST_ENABLE_YES,	NULL);

	for (i = 0; i < 100; i++)
		errs	+= ao8_reg_write(fd, -1, 0, AO8_GSC_AOBR, 0);

	errs	+= ao8_irq_enable	(fd, -1, 0, AO8_IRQ_BURST_READY,	NULL);
	errs	+= ao8_clock_enable	(fd, -1, 0, AO8_CLOCK_ENABLE_YES,	NULL);
	return(errs);
}



//*****************************************************************************
static int _irq_burst_ready_test(int fd)
{
	int	errs	= 0;

	gsc_label("Burst Ready");
	errs	+= ao8_initialize(fd, -1, 0);
	errs	+= irq_wait_test(fd, AO8_WAIT_GSC_BURST_READY, _burst_ready);
	errs	+= ao8_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _buf_error(int fd)
{
	int	errs	= 0;

	errs	+= ao8_buf_mode		(fd, -1, 0, AO8_BUF_MODE_CIRC,	NULL);
	errs	+= ao8_irq_enable	(fd, -1, 0, AO8_IRQ_BUF_ERROR,	NULL);
	errs	+= ao8_reg_write	(fd, -1, 0, AO8_GSC_AOBR, 0);
	return(errs);
}



//*****************************************************************************
static int _irq_buf_error_test(int fd)
{
	int	errs	= 0;

	gsc_label("Buffer Error");
	errs	+= ao8_initialize(fd, -1, 0);
	errs	+= irq_wait_test(fd, AO8_WAIT_GSC_BUF_ERROR, _buf_error);
	errs	+= ao8_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _auto_cal(int fd)
{
	int	errs	= 0;

	errs	+= ao8_irq_enable		(fd, -1, 0, AO8_IRQ_AUTO_CAL_DONE, NULL);
	errs	+= ao8_auto_calibrate	(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _irq_auto_cal_done_test(int fd)
{
	int	errs	= 0;

	gsc_label("Auto-Calibrate Done");
	errs	+= ao8_initialize(fd, -1, 0);
	errs	+= irq_wait_test(fd, AO8_WAIT_GSC_AUTO_CAL_DONE, _auto_cal);
	errs	+= ao8_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int	errs	= 0;

	gsc_label("IRQ");
	printf("\n");
	gsc_label_level_inc();

	errs	+= _irq_selftest_data_ready_test(args->fd);
	errs	+= _irq_dio0_l2h_test(args->fd);
	errs	+= _irq_buf_thr_h2l_test(args->fd);
	errs	+= _irq_buf_thr_l2h_test(args->fd);
	errs	+= _irq_load_ready_h2l_test(args->fd);
	errs	+= _irq_load_ready_l2h_test(args->fd);
	errs	+= _irq_burst_ready_test(args->fd);
	errs	+= _irq_buf_error_test(args->fd);
	errs	+= _irq_auto_cal_done_test(args->fd);

	gsc_label_level_dec();
	return(errs);
}


